# -*- coding: utf-8 -*-
"""TP1.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1_THIWOEMAoRsxbfc13-4l8dXBOCB4qcm
"""

#===============================================================================
# Exemplo: segmentação de uma imagem em escala de cinza.
#-------------------------------------------------------------------------------
# Professor: Bogdan T. Nassu
# Aluno: Arthur Jose A. Polli
# Universidade Tecnológica Federal do Paraná
#===============================================================================

import sys
import timeit
import numpy as np
import cv2

#===============================================================================

INPUT_IMAGE =  '/content/drive/My Drive/MESTRADO/UTFPR_COMP_APLIC/01_PDI/TP/teste.jpeg'

# TODO: ajuste estes parâmetros!
NEGATIVO = False
#TENTATIVA E ERRO
THRESHOLD = 0.8

#BASEADO NOS MENORES ELEMENTOS DA IMAGEM
ALTURA_MIN = 1
LARGURA_MIN = 1
N_PIXELS_MIN = 10


#-------------------------------------------------------------------------------
def binariza (img, threshold):

    binariazada = np.where(img<threshold,0,1)

    return binariazada

#===============================================================================
#calcula vizinhança 4
def vizinhanca4(yo,xo):
  S = np.ones([4,2], dtype=int)
  
  S[0,0]= yo-1 
  S[0,1] = xo
  S[1,0] = yo+1
  S[1,1] = xo
  S[2,0] = yo
  S[2,1] = xo-1
  S[3,0] = yo
  S[3,1] = xo+1
  return S
#===============================================================================  
#cria label nos blobs  
def inunda(label,img,yo,xo,comp):
    
    l,c,d = img.shape
    img[yo,xo] = label
    #numero de pixels
    comp [1] += 1
    # ymin
    if yo < comp[2]:
        comp[2] = yo
    # xmin
    if xo < comp[3]:
        comp[3] = xo
    # ymax
    if yo > comp[4]:
        comp[4] = yo
    #xmax
    if xo > comp[5]:
        comp[5] = xo
    #para cada vizinho de xo,yo
    viz = vizinhanca4(yo,xo)
    for i in range(4):
        # SE ELE É FOREGROUND FALTA IMPLEMENTAR SE ESTA DENTRO DA IMAGEM....
        '''AQUI'''
        if img[viz[i,0],viz[i,1]] == -1 and viz[i,0]>=0 and viz[i,0]<=l and viz[i,1]>=0 and viz[i,1]<=c :
            comp = inunda(label,img,viz[i,0],viz[i,1],comp)
    return comp
#===============================================================================

def rotula (img,largura_min, altura_min, n_pixels_min):
    #Preparação da imagem, mudar(1 para -1)
    rows, cols, channel = img.shape
    img = np.where(img>0,-1,0)
    label = 1
    Label = []
    NumPixels = []
    yMin = []
    xMin = []
    yMax = []
    xMax = []
    for row in range (rows):
      for col in range (cols):
        #Onde tem arroz
        if img[row,col] == -1: 
            comp=[label,0,row,col,row,col]
          #retorna a componente de um blob
            comp = inunda(label,img,row,col,comp)
            key = str(comp[0])
          #array para guardar multiplos valores
            larg = comp[5]-comp[3]
            alt = comp[4]-comp[2]
            if comp[1]>=n_pixels_min and larg>=largura_min and alt>=altura_min:
                Label.append(comp[0])
                NumPixels.append(int(comp[1]))
                yMin.append(int(comp[2]))
                xMin.append(int(comp[3]))
                yMax.append(int(comp[4]))
                xMax.append(int(comp[5]))
            label = label + 1
    compDic={
        "Label": Label,
        "NumPixels": NumPixels,
        "yMin": yMin,
        "xMin": xMin,
        "yMax": yMax,
        "xMax": xMax
    }
    return compDic

#===============================================================================

def main ():

    # Abre a imagem em escala de cinza.
    img = cv2.imread (INPUT_IMAGE, cv2.IMREAD_GRAYSCALE)
    if img is None:
        print ('Erro abrindo a imagem.\n')
        sys.exit ()
    rows, cols = img.shape

    # É uma boa prática manter o shape com 3 valores, independente da imagem ser
    # colorida ou não. Também já convertemos para float32.
    img = img.reshape ((img.shape [0], img.shape [1], 1))
    img = img.astype (np.float32) / 255

    # Mantém uma cópia colorida para desenhar a saída.
    img_out = cv2.cvtColor (img, cv2.COLOR_GRAY2BGR)

    # Segmenta a imagem.
    if NEGATIVO:
        img = 1 - img
    img = binariza (img, THRESHOLD)
    saida = '/content/drive/My Drive/MESTRADO/UTFPR_COMP_APLIC/01_PDI/TP/001 - binarizada.png'
    #cv2.imshow ('01 - binarizada', img)
    cv2.imwrite (saida, img*255)

    start_time = timeit.default_timer ()
    componentes = rotula (img, LARGURA_MIN, ALTURA_MIN, N_PIXELS_MIN)

    n_componentes = len (componentes['Label'])
    print ('Tempo: %f' % (timeit.default_timer () - start_time))
    print ('%d componentes detectados.' % n_componentes)

    # Mostra os objetos encontrados.
    for c in range(n_componentes):
        #print(componentes['xMin'][c])
        pt1 = (componentes['xMin'][c],componentes['yMax'][c])
        pt2 = (componentes['xMax'][c],componentes['yMin'][c])
        
        cv2.rectangle(img_out,pt1,pt2,(0,0,1))
        

    #cv2.imshow ('02 - out', img_out)
    saida2 = '/content/drive/My Drive/MESTRADO/UTFPR_COMP_APLIC/01_PDI/TP/002 - rotulada.png'
    cv2.imwrite (saida2, img_out*255)
    #cv2.waitKey ()
    #cv2.destroyAllWindows ()


if __name__ == '__main__':
    main ()

#===============================================================================

a = [0,1,2,3,4,5]
b= []
print(len(b))
for i in range(1,len(a)):
    print(a[i])